<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<div *ngIf="appShowSearch" class="filters--searchbar">
  <span class="filters--searchbar--text">{{"search.title" | translate}}</span>
  <app-searchbar
    (appSearch)="setSearchParameter('q', $event)"
    [appIsLoading]="appLoading"
    [appPlaceholder]="'search.executeSearch' | translate"
    class="filters--searchbar--input">
  </app-searchbar>

  <ng-content></ng-content>
</div>

<div class="filters">

  <button (click)="disableAllFilters()"
          class="openk-button openk-button-rounded"
          type="button">
    <mat-icon>filter_list</mat-icon>
  </button>

  <div class="all-filters">
    <div *ngIf="appFilters.typeId != null || appFilters.editedByMe != null || appFilters.finished != null"
         class="filters--row">
      <div class="filter-group filter-group---stacked">
        <button
          (click)="toggleSearchParameter('typeId', typeSelect.appValue)"
          [class.openk-info]="appValue.typeId != null"
          class="openk-button openk-chip filters--btn filters--btn---margin">
          {{"search.type" | translate}}
        </button>
        <div class="filters--type-select-width">
          <app-select #typeSelect
                      (appValueChange)="setSearchParameter('typeId', $event)"
                      [appDisabled]="appStatementTypeOptions?.length == null || appStatementTypeOptions.length === 0"
                      [appOptions]="appStatementTypeOptions"
                      [appPlaceholder]="typeSelect.appDisabled ? ('search.noData' | translate) : ''"
                      [appValue]="appStatementTypeOptions ? appStatementTypeOptions[0]?.value : undefined"
                      class="openk-info filters--select--input-width">
          </app-select>
        </div>
      </div>
      <div *ngIf="appFilters.finished != null"
           class="filter-group filter-group---stacked">
        <button
          (click)="toggleSearchParameter('finished', statusSelect.appValue)"
          [class.openk-info]="appValue.finished != null"
          class="openk-button openk-chip filters--btn filters--btn---margin">
          Status
        </button>
        <div class="filters--finished-select-width">
          <app-select #statusSelect
                      (appValueChange)="setSearchParameter('finished', statusSelect.appValue)"
                      [appOptions]="finishedOptions$ | async"
                      [appValue]="(finishedOptions$ | async)?.length > 0 ? (finishedOptions$ | async)[0].value : statusSelect.appValue"
                      class="openk-info filters--select--input-width">
          </app-select>
        </div>
      </div>
      <div *ngIf="appFilters.editedByMe != null"
           class="filter-group filter-group---stacked">
        <button
          (click)="toggleSearchParameter('editedByMe', true)"
          [class.openk-info]="appValue.editedByMe != null"
          class="openk-button openk-chip filters--btn">
          {{"search.editedByMe" | translate}}
        </button>
      </div>
      <div *ngIf="appFilters.canceled != null"
           class="filter-group filter-group---stacked">
        <button
          (click)="toggleSearchParameter('canceled', true)"
          [class.openk-info]="appValue.canceled != null"
          class="openk-button openk-chip filters--btn">
          {{"search.canceled" | translate}}
        </button>
      </div>
    </div>
    <div class="filters--date-selects">
      <div *ngIf="appFilters.creationDateFrom != null || appFilters.creationDateTo != null"
           class="filter-group filter-group---stacked">
        <div class="filters--date-selects--block">
          <app-date-filter
            #creationDateFrom
            (appValueChange)="setSearchParameter('creationDateFrom', creationDateFrom.appActive ? $event : null)"
            *ngIf="appFilters.creationDateFrom != null"
            [appActive]="appValue.creationDateFrom != null"
            [appTitle]="'search.creationDateFrom' | translate">
          </app-date-filter>
          <app-date-filter
            #creationDateTo
            (appValueChange)="setSearchParameter('creationDateTo', creationDateTo.appActive ? $event : null)"
            *ngIf="appFilters.creationDateTo != null"
            [appActive]="appValue.creationDateTo != null"
            [appTitle]="'search.creationDateTo' | translate">
          </app-date-filter>
        </div>
      </div>
      <div *ngIf="appFilters.dueDateFrom != null || appFilters.dueDateTo != null"
           class="filter-group filter-group---stacked">
        <div class="filters--date-selects--block">
          <app-date-filter
            #dueDateFrom
            (appValueChange)="setSearchParameter('dueDateFrom', dueDateFrom.appActive ? $event : null)"
            *ngIf="appFilters.dueDateFrom != null"
            [appActive]="appValue.dueDateFrom != null"
            [appTitle]="'search.dueDateFrom' | translate">
          </app-date-filter>
          <app-date-filter
            #dueDateTo
            (appValueChange)="setSearchParameter('dueDateTo', dueDateTo.appActive  ? $event : null)"
            *ngIf="appFilters.dueDateTo != null"
            [appActive]="appValue.dueDateTo != null"
            [appTitle]="'search.dueDateTo' | translate">
          </app-date-filter>
        </div>
      </div>
      <div *ngIf="appFilters.receiptDateFrom != null || appFilters.receiptDateTo != null"
           class="filter-group filter-group---stacked">
        <div class="filters--date-selects--block">
          <app-date-filter
            #receiptDateFrom
            (appValueChange)="setSearchParameter('receiptDateFrom', receiptDateFrom.appActive ? $event : null)"
            *ngIf="appFilters.receiptDateFrom != null"
            [appActive]="appValue.receiptDateFrom != null"
            [appTitle]="'search.receiptDateFrom' | translate">
          </app-date-filter>
          <app-date-filter
            #receiptDateTo
            (appValueChange)="setSearchParameter('receiptDateTo', receiptDateTo.appActive ? $event : null)"
            *ngIf="appFilters.receiptDateTo != null"
            [appActive]="appValue.receiptDateTo != null"
            [appTitle]="'search.receiptDateTo' | translate">
          </app-date-filter>
        </div>
      </div>
    </div>
  </div>
</div>

